unit Unit3;

interface

uses
  System.SysUtils, System.Classes, JS, Web, WEBLib.Graphics, WEBLib.Controls,
  WEBLib.Forms, WEBLib.Dialogs, Vcl.StdCtrls, WEBLib.StdCtrls, Vcl.Controls,
  WebLib.REST,
  WebAudio
  ;

type
  TForm3 = class(TWebForm)
    WebButton1: TWebButton;
    lbox1: TWebListBox;
    Memo1: TWebMemo;
    procedure WebButton1Click(Sender: TObject);

  private
    [async] procedure Player_test;
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

//==============================================================
procedure TForm3.WebButton1Click(Sender: TObject);
//==============================================================
begin
  Player_test;
end;

//==============================================================
procedure TForm3.Player_test;
//==============================================================
var
  AContext:  TJSAudioContext;
  AGainNode: TJSGainNode;
  ABufferSourceNode: TJSAudioBufferSourceNode;

  ARequest: TWebHTTPRequest;
  AResponse : TJSXMLHTTPRequest;

  ms : TMemoryStream;
  s : string;

begin
  AContext := TJSAudioContext.New;
  AGainNode := AContext.CreateGain;
  ABufferSourceNode := AContext.CreateBufferSource;
  ABufferSourceNode.Connect( AContext.Destination );
(*
  ms := TMemoryStream.Create;
  ms.LoadFromURL(lbox1.Items[0], false);

  memo1.Lines.Add( Format( 'Loaded into stream; Length=%d', [ms.Position] ) );
  ms.Position := 0;

*)
  ARequest := TWebHTTPRequest.Create(Self);
  ARequest.Headers.Add( 'Access-Control-Allow-Origin=*' );


  ARequest.URL := lbox1.Items[0];
//  ARequest.URL := 'https://www.dropbox.com/s/4mn8ihrhbkl0gux/snippet1.mp3?dl=1';
  ARequest.ResponseType := rtArrayBuffer;

  try
    AResponse := await( TJSXMLHTTPRequest,
                        ARequest.Perform() );

    ABufferSourceNode.Buffer := await( TJSAudioBuffer,
                                AContext.DecodeAudioData(TJSArrayBuffer(AResponse.Response)));
    ABufferSourceNode.Start;

  except
    on E: Exception do
    begin
      // file not found, etc.
      ShowMessage(E.ClassName+': '+E.Message);
    end;
  end;

end;

end.